<template>
  <div
    style="
      margin: 0 0px;
      overflow-y: scroll;
      overflow-x: hidden;
      background-color: #ECECEC;

      position: absolute; 
      z-index: 2; 
      top: 0; 
      bottom: 0; 
      left: 0; 
      right: 0;
      overflow: hidden; 
      display: flex; 
      flex-direction: column; 
      box-sizing: border-box;
    "
  >
    <div class="header">
      <div
        :style="`background-image: url(${require('@/assets/img/arrow-back.svg')})`"
        @click="$emit('back')"
        style="
          position: absolute;
          left: 12px;
          top: 45px;
          overflow: hidden;
          cursor: pointer;
          text-align: center;
          box-sizing: border-box;
          padding: 20px;
          background-repeat: no-repeat;
          background-position: center;
        "
      >
      </div>
      Список товаров</div>

      <div style="height: 101px;">

      </div>

    <!-- <div
      v-for="(good, index) in goodsList"
      :key="good.id"
      style="margin: 1px 0; background: rgb(255, 0, 26); background: linear-gradient(90deg,rgba(255, 0, 26, 1) 0%, rgba(42, 24, 181, 1) 100%);">
      <div
        @touchstart="handleTouchStart($event)"
        @touchmove="handleTouchMove($event, good, index)"
        @touchend="touchStart = 0; touchDistance = 0; $event.target.style.left = '-5px'; isScrolling = null"
        style="
          position: relative;
          overflow: hidden;
          background-color: #ffffff;
          padding: 30px 80px 30px 50px;
          text-align: left;
          text-overflow: ellipsis;
          white-space: nowrap;
          overflow: hidden;
          left: -5px;
        "
      >
        <span
          style="pointer-events: none; "

          >{{ good.name }}</span
        >
        <br />
        <span
          style="pointer-events: none"

          >{{ good.price }}₸</span
        >
        <div
          v-if="good.chosenAmount"
          style="
            pointer-events: none;
            position: absolute;
            left: 20px;
            top: calc(50% - 8px);
          "
        >
          {{ good.chosenAmount }}x
        </div>
        <div
          :style="`background-image: url( ${require(`@/assets/img/${good.img_url}`)} )`"
          style="
            pointer-events: none;
            position: absolute;
            width: 35px;
            height: 35px;
            right: 35px;
            top: calc(50% - 16px);
            background-size: contain;
          "
        ></div>
      </div>
    </div> -->

    <div
      v-for="(good, index) in $store.state.inventories"
      :key="good.product_id"
      style="margin: 1px 0; background: rgb(255, 0, 26); background: linear-gradient(90deg,rgba(255, 0, 26, 1) 0%, rgba(42, 24, 181, 1) 100%);">
      <div
        @touchstart="handleTouchStart($event)"
        @touchmove="handleTouchMove($event, good, index)"
        @touchend="touchStart = 0; touchDistance = 0; $event.target.style.left = '-5px'; isScrolling = null"
        style="
          position: relative;
          overflow: hidden;
          background-color: #ffffff;
          padding: 30px 80px 30px 50px;
          text-align: left;
          text-overflow: ellipsis;
          white-space: nowrap;
          overflow: hidden;
          left: -5px;
        "
      >
        <span
          style="pointer-events: none; "

          >{{ good.product.name }}</span
        >
        <br />
        <span
          style="pointer-events: none"

          >{{ good.price_actual }}₸</span
        >
        <div
          v-if="good.chosenAmount"
          style="
            pointer-events: none;
            position: absolute;
            left: 20px;
            top: calc(50% - 8px);
          "
        >
          {{ good.chosenAmount }}x
        </div>
        <!-- <div
          :style="`background-image: url( ${require(`@/assets/img/${good.img_url}`)} )`"
          style="
            pointer-events: none;
            position: absolute;
            width: 35px;
            height: 35px;
            right: 35px;
            top: calc(50% - 16px);
            background-size: contain;
          "
        ></div> -->
      </div>
    </div>

  </div>
</template>

<script>
export default {
  data() {
    return {
      xDown: null,
      yDown: null,
      touchStart: 0,
      touchDistance: 0,
      swiped: false,
      isScrolling: null,
      start: {
        x: null,
        y: null,
      },
      delta: {
        x: null,
        y: null
      }
    }
  },
  props: {
    goodsList: Array
  },
  created() {
    this.$store.dispatch('getShopInventories')
  },
  methods: {
    // handleTouchMove(evt, good, index) {
    //   console.log('working');
    //   if ( !this.xDown || !this.yDown ) {
    //     return;
    //   }

    //   var xUp = evt.touches[0].clientX;                                    
    //   var yUp = evt.touches[0].clientY;

    //   var xDiff = this.xDown - xUp;
    //   var yDiff = this.yDown - yUp;
                                                                          
    //   if ( Math.abs( xDiff ) > Math.abs( yDiff ) ) {
    //     if ( xDiff > 0 ) {
    //       /* right swipe */
    //       console.log('влево', xDiff);
    //       evt.preventDefault();
    //       evt.stopPropagation();

    //       evt.target.style.position = 'relative';
    //       evt.target.style.left = -xDiff + 'px';
    //       // evt.target.style.borderRight = 'none';
          
    //       this.$emit('addGood', index);
            
    //     } else {
    //       /* left swipe */
    //       console.log('вправо', xDiff);
    //       evt.preventDefault();
    //       evt.stopPropagation();

    //       evt.target.style.position = 'relative';
    //       evt.target.style.left = -xDiff + 'px';
    //       // evt.target.style.borderLeft = 'none';

    //       if (good.chosenAmount > 0) {
    //         this.$emit('removeGood', index);
    //       }
    //     }                       
    //   }

    //   /* reset values */
    //   this.xDown = null;
    //   this.yDown = null;                                             
    // }, 

    handleTouchStart(event) {

      event.stopPropagation();
      this.touchStart = event.touches[0].clientX;

      this.start.x = event.touches[0].pageX;
      this.start.y = event.touches[0].pageY;
    },

    handleTouchMove(event, good, index) {

      this.delta.x = event.touches[0].pageX - this.start.x;
      this.delta.y = event.touches[0].pageY - this.start.y;

      if (this.isScrolling == null) {
        this.isScrolling = !!( this.isScrolling || Math.abs(this.delta.x) < Math.abs(this.delta.y) );
      }

      console.log(this.delta.x, this.delta.y);
      this.touchDistance = event.touches[0].clientX - this.touchStart;

      if (!this.isScrolling) {
        

      // if (this.touchDistance > 5) {
        event.preventDefault();
      // }

      // if (this.touchDistance > 10 || this.touchDistance < 10) {
        
        event.target.style.left = this.touchDistance + 'px';

      // }

      if (parseInt(event.target.style.left, 10) < -85) {
        event.target.style.left = '-85px';
      }

      if (parseInt(event.target.style.left, 10) > 85) {
        event.target.style.left = '85px';
      }

      if (parseInt(event.target.style.left, 10) < -80 && this.swiped === false) {
        this.$emit('addGood', index);
      } else if (parseInt(event.target.style.left, 10) > 80 && this.swiped === false) {
        if (good.chosenAmount > 0) {
          this.$emit('removeGood', index);
        }
      }
      
      if (parseInt(event.target.style.left, 10) < -80 || 
            parseInt(event.target.style.left, 10) > 80 && 
              (this.swiped === false)) {
        this.swiped = true;
      } else if (parseInt(event.target.style.left, 10) >= -80 && 
                  parseInt(event.target.style.left, 10) <= 80 && 
                    (this.swiped === true)) {
        this.swiped = false;              
      }

    }
      
    }

  }
};
</script>

<style scoped>
  .header {
    position: fixed;
    z-index: 2;
    left: 0;
    right: 0;
    text-align: center; 
    padding: 57px 10px 25px 10px;
    background-color: #f5f5f5;
  }
</style>